package java.io;

import sun.misc.SharedSecrets;
import java.util.Iterator;
import java.util.Collections;
import java.util.ArrayList;
import java.util.LinkedHashSet;

class DeleteOnExitHook
{
    private static LinkedHashSet<String> files;
    
    private DeleteOnExitHook() {
    }
    
    static synchronized void add(String e) {
        if (DeleteOnExitHook.files == null) {
            throw new IllegalStateException("Shutdown in progress");
        }
        DeleteOnExitHook.files.add(e);
        return;
    }
    
    static void runHooks() {
        LinkedHashSet<Object> files;
        synchronized (DeleteOnExitHook.class) {
            files = DeleteOnExitHook.files;
            DeleteOnExitHook.files = null;
        }
        ArrayList<Object> list = new ArrayList(files);
        Collections.reverse(list);
        Iterator<Object> iterator = list.iterator();
        while (iterator.hasNext()) {
            new File((String)iterator.next()).delete();
        }
    }
    
    static {
        DeleteOnExitHook.files = new LinkedHashSet();
        SharedSecrets.getJavaLangAccess().registerShutdownHook(2, true, new Runnable() {
            @Override
            public void run() {
                DeleteOnExitHook.runHooks();
            }
        });
    }
}
